#!/bin/bash

autoconf --version &> /dev/null || {
  echo
  echo "**Error**: You must have \`autoconf' installed to compile this package."
  exit 1
}

libtoolize --version &> /dev/null || {
  echo
  echo "**Error**: You must have \`libtool' installed to compile this package."
  exit 1
}

gtkdocize --version &> /dev/null || {
  echo
  echo "**Error**: You must have \`gtkdocize' installed to compile this package."
  exit 1
}

automake --version &> /dev/null || {
  echo
  echo "**Error**: You must have \`automake' installed to compile this package."
  exit 1
}

aclocal --version &> /dev/null || {
  echo
  echo "**Error**: You must have \`aclocal' installed to compile this package."
  exit 1
}

echo "aclocal..."
aclocal &> /dev/null || exit 1

echo "autoheader..."
autoheader &> /dev/null || exit 1

echo "libtoolize..."
libtoolize --force --copy &> /dev/null || exit 1

echo "gtkdocize..."
gtkdocize &> /dev/null || exit 1

echo "automake..."
automake --copy --gnu --add-missing &> /dev/null || exit 1

echo "autoconf..."
autoconf &> /dev/null || exit 1

rm -rf autom4te.cache &>/dev/null

echo "Bye :)"
