/* SPRpc - Copyright (C) 2008 Andrea Marchesini <baku@autistici.org>
 *                            Rocco De Patto    <lesion@autistici.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <stdio.h>
#include <sp_rpc.h>

int
main (void)
{
  gchar *name;

  SPRpcValue *value;
  SPRpcParams *params;
  SPRpcIter iter;

  params = sp_rpc_params_new ();

  value = sp_rpc_value_new ();
  sp_rpc_value_set_type (value, SP_RPC_TYPE_NUMBER);
  sp_rpc_value_set_number (value, 123);
  sp_rpc_params_add (params, "number", value);

  value = sp_rpc_value_new ();
  sp_rpc_value_set_type (value, SP_RPC_TYPE_STRING);
  sp_rpc_value_set_string (value, "hello world");
  sp_rpc_params_add (params, "string", value);

  sp_rpc_params_iter_init (params, &iter);

  while (sp_rpc_params_iter_next (&iter, &name, &value) == TRUE)
    {
      gchar *str;

      printf ("Name: %s - ", name);

      switch (sp_rpc_value_get_type (value))
	{
	case SP_RPC_TYPE_STRING:
	  str = sp_rpc_value_get_string (value);
	  printf ("string(%s)\n", str);
	  g_free (str);
	  break;

	case SP_RPC_TYPE_NUMBER:
	  printf ("string(%f)\n", sp_rpc_value_get_number (value));
	  break;

	default:
	  printf ("?!?\n");
	  break;
	}
    }

  return 0;
}
