/* SPRpc - Copyright (C) 2008 Andrea Marchesini <baku@autistici.org>
 *                            Rocco De Patto    <lesion@autistici.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <stdio.h>
#include <string.h>

#include <sp_rpc.h>

int
main (void)
{
  gchar group[MAX_GROUP_NAME];
  gchar sender[MAX_GROUP_NAME];
  gchar groups[10][MAX_GROUP_NAME];
  gchar buffer[1024];
  gint ngroups;
  gint16 mtype;
  gint ret;
  gint em;

  service service;
  mailbox mbox;

  if (SP_connect ("4803", NULL, 0, 0, &mbox, group) != ACCEPT_SESSION)
    {
      fprintf (stderr, "Error connecting to the Spread Ring\n");
      return 0;
    }

  SP_join (mbox, "TEST_GROUP");

  while (1)
    {
      service = 0;
      ret =
	SP_receive (mbox, &service, sender, 10, &ngroups, groups, &mtype, &em,
		    sizeof (buffer), buffer);

      if (ret < 0 || ret == BUFFER_TOO_SHORT || ret == GROUPS_TOO_SHORT)
	{
	  fprintf (stderr, "Error receiving the message: ");
	  SP_error (ret);
	  break;
	}

      if (buffer[ret - 1] == '\n')
	ret--;

      buffer[ret] = 0;
      printf (" Received %d bytes: -%s-\n", ret, buffer);
    }

  SP_leave (mbox, "TEST_GROUP");
  SP_disconnect (mbox);
  return 0;
}
