/* SPRpc - Copyright (C) 2008 Andrea Marchesini <baku@autistici.org>
 *                            Rocco De Patto    <lesion@autistici.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <sp_rpc.h>

int
main (void)
{
  gchar group[MAX_GROUP_NAME];
  mailbox mbox;

  if (SP_connect ("4803", NULL, 0, 0, &mbox, group) != ACCEPT_SESSION)
    {
      fprintf (stderr, "Error connecting to the Spread Ring\n");
      return 0;
    }

  SP_join (mbox, "TEST_GROUP");

  while (1)
    {
      gchar buffer[1024];
      gint ret;

      if ((ret = read (0, buffer, sizeof (buffer))) < 0)
	break;

      if ((ret =
	   SP_multicast (mbox, FIFO_MESS, "TEST_GROUP", 1, ret, buffer)) <= 0)
	{
	  fprintf (stderr, "Error sending the message\n");
	  return 0;
	}

      printf ("Sent: %d bytes\n", ret);
    }

  SP_leave (mbox, "TEST_GROUP");
  SP_disconnect (mbox);
  return 0;
}
